#ifndef _ABOUTSCREEN_H_
#define _ABOUTSCREEN_H_

#include "image.h"
#include "imagemap.h"
#include "main.h"
#include "button.h"

class AboutScreen : public Screen {

	public:
	
	AboutScreen () {
		backButton = new Button(ImageMap::get("back"), 505, 475, backAction);
	}
	
	void handleInput (SDL_Event& event) {
		switch (event.type) {
			case SDL_KEYDOWN:
				keyDown(event);
			break;
			case SDL_QUIT:
				exit(0);
			break;
		}
	}
	
	void keyDown (SDL_Event& event) {
		switch (event.key.keysym.sym) {
			case SDLK_ESCAPE:
				transitionTo(titleScreen);
			break;
			
			default: {}
		}
	}	
	
	void update() {
			backButton->update();
	};

	void draw() const {
		ImageMap::get("background")->draw(0, 0);
		ImageMap::get("aboutscreen")->draw(0, 0);
		
		backButton->draw();
	};

	private:
	
	static void backAction (Button* b) {
		transitionTo(titleScreen);
	}
	
	Button* backButton;

};

#endif
