#ifndef _ANIMATION_H_
#define _ANIMATION_H_

#include <list>

/**
 * An instance of animation contains a list of frames and methods for stepping through
 * those frames in order.
 */
class Animation {

  public:
  Animation (int stepDelay, std::list<int> frameList) : stepDelay(stepDelay), stepCounter(stepDelay), frameList(frameList), frameIterator(frameList.begin()) {reset();};
  int getFrame () { return *frameIterator; };
  void step ();
  void reset () { frameIterator = frameList.begin(); stepCounter = stepDelay; };

  private:
  int stepDelay;
  int stepCounter;
  std::list<int> frameList;
  std::list<int>::iterator frameIterator;

};

#endif