#ifndef _ENTITY_H_
#define _ENTITY_H_

// Should we actually check if the compiler is Visual Studio?
#ifdef _MSC_VER

// Disable warning about converting float to int -- we do that a lot
#pragma warning( disable: 4244 )

#endif

#include "image.h"

class Tile;

class Entity {
	public:
	
	Entity () {}
	virtual ~Entity () {}
	
	virtual void update () = 0;
	virtual void draw () const = 0;
	
	virtual int l () const = 0;
	virtual int r () const = 0;
	virtual int t () const = 0;
	virtual int b () const = 0;
	
	virtual int offsetL () const = 0;
	virtual int offsetR () const = 0;
	virtual int offsetT () const = 0;
	virtual int offsetB () const = 0;
	
	virtual int getLayer () const = 0;
	virtual int getType () const = 0;
	
	virtual bool squashable () const = 0;
	virtual bool pushable () const = 0;
	
	bool contains (int x, int y) const {
		return (x >= l() && x <= r() && y >= t() && y <= b());
	}
	
	int getWidth () const { return r() - l(); }
	int getHeight () const { return b() - t(); }
	
	virtual bool solid () const = 0;
};

#endif

