#include "leveldata.h"

#include <iostream>
#include <fstream>

std::vector<LevelData*> LevelData::map;

void LevelData::init () {
	// Read files until we run out
	for (int i = 0; load(i); i++) {}
}

bool LevelData::load (int levelID) {
	std::stringstream s;
	
	s << "./levels/" << levelID << ".lvl";
	
	std::ifstream file(s.str().c_str());
	
	if (! file.is_open()) {
		return false;
	}
	
	LevelData* data = new LevelData();
	
	for (int y = 0; y < Level::HEIGHT; y++) {
		for (int x = 0; x < Level::WIDTH; x++) {
			file >> data->tileArray[x][y];
		}
	}
	
	file.close();
	
	map.push_back(data);
	
	return true;
}

Level* LevelData::create (int levelID) {
	return new Level(map[levelID]->tileArray);
}

