#ifndef _PLAYER_H_
#define _PLAYER_H_

#include "moving_entity.h"
#include "player.h"
#include "tile.h"
#include "animation.h"

class Player : public MovingEntity {
	public:
	
	Player (float x, float y);
	~Player () { delete walking; }
	
	void update ();
	void draw () const;
	
	void standingOn (Entity* entity);
	void bangingHead (Entity* entity);
	
	static const int STANDING = 0;
	static const int RIGHT_FOOT = 1;
	static const int LEFT_FOOT = 2;

	static const int NOTHING = 0;
	static const int BAT = 1;
	static const int SLINGSHOT = 2;

	// Bat frames.
	static const int SHOULDER = 0;
	static const int UPRIGHT = 1;
	static const int HITTING = 2;

	int offsetL () const { return 8; }
	int offsetR () const { return 23; }
	int offsetT () const { return 1; }
	int offsetB () const { return 32; }

	int getLayer() const { return Tile::MIDDLEGROUND; };
	int getType() const { return Tile::PLAYER; };
	
	void stoodOnBy (MovingEntity* entity, float speed);

	protected:
	bool standing;
	int fireDelay;
	int previousFrame;
	int weapon;
	int batFrame;
	int previousBatFrame;
	Entity* previousTile; // Used to check if the player has actually moved between updates.
	Animation* bat;
	Animation* walking;
};

#endif

