#ifndef _TEDDY_H_
#define _TEDDY_H_

#include "moving_entity.h"
#include "tile.h"
#include <iostream>

class Teddy : public MovingEntity {
	public:
	
	Teddy (float x, float y) : MovingEntity(x, y), broken(false) {
		image = ImageMap::get("teddy");
	}
	
	~Teddy () {};
	
	void update () {
		updateY();
	};

	void draw () const {
		MovingEntity::draw();
	};

	int offsetL () const { return 10; }
	int offsetR () const { return 22; }
	int offsetT () const { return 14; }
	int offsetB () const { return 32; }

	void breakTeddy() { if (!broken) {broken = true;
				 Level* level = Level::current(); level->teddiesAlive--;} };

	int getLayer() const { return Tile::MIDDLEGROUND; };	
	int getType() const { return Tile::TEDDY; };

	void standingOn (Entity* entity) {
		if (vy >= 12.0f) {
			breakTeddy();
		}
		
		MovingEntity::standingOn(entity);
	}

	void stoodOnBy (MovingEntity* entity, float speed) {
		if (entity->getType() != Tile::PLAYER) {
			breakTeddy();
		}
	}

	private:
	bool broken;
};

#endif

