#include "image.h"
#include "window.h"
#include "SDL_image.h"

Image::Image (const char* file, int splitWidth) : image(0) {
	SDL_Surface *temp;
	 
	temp = IMG_Load(file);
	if (temp == NULL) {
		printf("Unable to load bitmap: %s\n", SDL_GetError());

		return;
	}
		
	image = SDL_DisplayFormatAlpha(temp);
	SDL_FreeSurface(temp);
	
	width = image->w;
	height = image->h;
	
	if (splitWidth > 0) {
		count = width / splitWidth;
		width = splitWidth;
	} else {
		count = 1;
	}
}

void Image::drawFrame (int id, int x, int y, bool flip) const {
	SDL_Rect src, dest;

	if (flip) {
		id = count - 1 - id;
	}
	
	src.x = id * width;
	src.y = 0;
	src.w = width;
	src.h = height;
	 
	dest.x = x;
	dest.y = y;
	dest.w = width;
	dest.h = height;
	 
	SDL_BlitSurface(image, &src, Window::getSurface(), &dest);
}

